package main;

import problem.Action;
import problem.Node;
import problem.Problem;
import problem.State;

public class MyProblem extends Problem {

    private int[][] grid;
    public final static int CLEAR_TILE = 0;
    public final static int BLOCKED_TILE = 1;
    public final static int VISITED_TILE = 2;
    public final static int FRINGE_TILE = 3;
    public final static int PATH_TILE = 4;

    public MyProblem(State initState, State goalState, Action[] actions, int[][] grid) {
        super(initState, goalState, actions);
        this.grid = grid;
    }

    //SUCCESSOR-FN
    @Override
    public boolean isValidState(State s0) {
        MyState s = (MyState) s0;
        try {
            if (this.grid[s.getX()][s.getY()] != BLOCKED_TILE) {
                return true;
            }
        } catch (Exception e) {
        }
        return false;
    }

   
    @Override
    public void searchDone(Node goal) {
        while (goal != null) {
            MyState s = (MyState) goal.getState();
            this.grid[s.getX()][s.getY()] = PATH_TILE;
            goal = goal.getParent();

        }
    }

    @Override
    public void visited(Node n) {
        MyState s = (MyState) n.getState();
        grid[s.getX()][s.getY()] = VISITED_TILE;
    }

    @Override
    public void Clear(Node n) {
        MyState s = (MyState) n.getState();
        grid[s.getX()][s.getY()] = CLEAR_TILE;
    }

    @Override
    public void fring(Node n) {
        MyState s = (MyState) n.getState();
        grid[s.getX()][s.getY()] = FRINGE_TILE;
    }

    @Override
    public boolean isVisited(Node n) {
        MyState s = (MyState) n.getState();
        return grid[s.getX()][s.getY()] == VISITED_TILE;
    }

    
    @Override
    public boolean isFring(Node n) {
        MyState s = (MyState) n.getState();
        return grid[s.getX()][s.getY()] == FRINGE_TILE;
    }
    
    @Override
    public void reset() {
        for (int i = 0; i < 25; i++) {
            for (int j = 0; j < 25; j++) {
                if (grid[i][j] != BLOCKED_TILE) {//reset visited node
                    grid[i][j] = CLEAR_TILE;
                }
            }
        }
    }

    @Override
    public int calculateHeuristic(Node n) {
        MyState s = (MyState) n.getState();
        MyState g = (MyState) goalState;
        return Math.abs(g.getX() - s.getX()) + Math.abs(g.getY() - s.getY());
    }

    @Override
    public boolean isClear(Node n) {
         MyState s = (MyState) n.getState();
        return grid[s.getX()][s.getY()] == CLEAR_TILE;
    }

}
