package problem;

public abstract class Problem {

    protected final State initState, goalState;
    protected Action actions[];

    public Problem(State initState, State goalState, Action[] actions) {
        this.initState = initState;
        this.goalState = goalState;
        this.actions = actions;
    }

    public State getInitState() {
        return initState;
    }

    public State getGoalState() {
        return goalState;
    }

    public Action[] getActions() {
        return actions;
    }

    public boolean isGoal(Node current) {
        return this.goalState.equals(current.state);
    }

    public float getF(Node n){
        return n.getG()+this.calculateHeuristic(n);
    }
    
    public abstract boolean isValidState(State s);

    public abstract void searchDone(Node goal);

    public abstract void visited(Node n);

    public abstract void Clear(Node n);

    public abstract void fring(Node n);

    public abstract boolean isFring(Node n);
    
    public abstract boolean isVisited(Node n);
    
    public abstract boolean isClear(Node n);

    public abstract void reset();

    public abstract int calculateHeuristic(Node n);
}
