package strategy;

import java.util.LinkedHashSet;
import java.util.LinkedList;
import problem.Action;
import problem.Node;
import problem.Problem;
import problem.State;

public class BreadthFirstSearch extends Strategy {

    @Override
    public Node Solve(Problem problem) {
        this.resetCalculatedComplexity();
        LinkedHashSet<State> h = new LinkedHashSet<>();

        LinkedList<Node> queue = new LinkedList<>();
        Action[] action = problem.getActions();

        queue.add(new Node(problem.getInitState()));
        this.incrementNumberOfNode();
        
        while (!queue.isEmpty()) {

            Node parent = queue.remove();
            
            problem.visited(parent);
            
            //goal test
            if (problem.isGoal(parent)) {
                return parent;
            }

            //Expand
            for (Action a : action) {
                State s = a.getNextState(parent.getState());
                if (problem.isValidState(s)) {
                    Node n = new Node(s, parent,a);
                    if (problem.isClear(n)) {
                        
                        queue.add(n);
                        this.incrementNumberOfNode();
                        problem.fring(n);
                        
                    }
                }
            }
        }
        return null;

    }
@Override
    public String toString() {
        return "Breadth First";
    }
    
}