package strategy;

import java.util.Stack;
import problem.Action;
import problem.Node;
import problem.Problem;
import problem.State;

public class DepthFirstSearch extends Strategy {

    @Override
    public Node Solve(Problem problem) {
        this.resetCalculatedComplexity();
        Action[] action = problem.getActions();

        Stack<Node> stack = new Stack<>();

        stack.push(new Node(problem.getInitState()));
        this.incrementNumberOfNode();

        while (!stack.isEmpty()) {

            Node parent = stack.pop();
            this.decrementNumberOfNode();

            problem.visited(parent);

            //goal test
            if (problem.isGoal(parent)) {
                return parent;
            }

            //Expand
            for (Action a : action) {
                State s = a.getNextState(parent.getState());
                if (problem.isValidState(s)) {
                    Node n = new Node(s, parent,a);
                    if (problem.isClear(n)) {

                        stack.push(n);
                        this.incrementNumberOfNode();
                        problem.fring(n);
                    
                    }
                }
            }
        }
        return null;

    }

    @Override
    public String toString() {
        return "Depth First";
    }
}