package strategy;

import java.util.Stack;
import problem.Action;
import problem.Node;
import problem.Problem;
import problem.State;

public class IterativeDeepeningSearch extends Strategy {

    private Problem problem;
    private Action[] action;

    @Override
    public Node Solve(Problem problem) {
        this.resetCalculatedComplexity();
        this.problem = problem;
        this.action = problem.getActions();

        int depth = 0;
        while (depth < Integer.MAX_VALUE) {
            Node n = DFLS(depth);
           
            if (n != null) {
                return n;
            }
            depth++;
        }
        return null;

    }

    private Node DFLS(int limit) {
        this.problem.reset();


        Stack<Node> stack = new Stack<>();

        stack.push(new Node(problem.getInitState()));
        this.incrementNumberOfNode();

        while (!stack.isEmpty()) {

            Node parent = stack.pop();
            this.decrementNumberOfNode();
            problem.visited(parent);
            
            //goal test
            if (problem.isGoal(parent)) {
                return parent;
            }

            //Expand
            if (parent.getDepth() < limit) {
                for (Action a : action) {
                    State s = a.getNextState(parent.getState());
                    if (problem.isValidState(s)) {
                        Node n = new Node(s, parent,a);
                        if (problem.isClear(n)) {

                            stack.push(n);
                            this.incrementNumberOfNode();

                            problem.fring(n);
                        }
                    }
                }
            }
        }
        return null;

    }
    
//    @Override
//    public Node Solve(Problem problem) {
////        System.out.println("_______________________________________________________________");
//        action = problem.getActions();
//        for (int limit = 0; limit < 1000; limit++) {
//            problem.reset();
//            Result r = RDLS(new Node(problem.getInitState()), problem, limit);
//            if (!r.isCutOff()) {
//                return r.node;
//            }
////            System.out.println("______________");
//        }
//        return null;
//
//    }
//
//    private Result RDLS(Node node, Problem problem, int limit) {
//        boolean cutoffOccurred = false;
////        System.out.println(limit+"       "+node+"     =>"+node.getDepth() );
//        problem.visited(node);
//
//        if (problem.isGoal(node)) {
//            return new Result().solotion(node);
//
//        } else if (node.getDepth() == limit) {
////            System.out.println("--");
//            return new Result().cutOff();
//
//        } else {
//            for (Action a : action) {
//                State s = a.getNextState(node.getState());
//                if (problem.isValidState(s)) {
//                    Node n = new Node(s, node);
//                    if (!problem.isVisited(n)) {
//                    Result result = RDLS(n, problem, limit);
//
//                    if (result.isCutOff()) {
////                        while ((n=n.getParent() )!= null) {
////                            problem.Clear(n);
////                        }
//                        cutoffOccurred = true;
//                    } else if (!result.isFailure()) {
//                        return result;
//                    }
////                        problem.fring(n);
//                    }
//                }
//            }
//        }
//
//        if (cutoffOccurred) {
//            return new Result().cutOff();
//        } else {
//            return new Result().failure();
//        }
//    }
//
//    class Result {
//
//        Node node;
//        private int type = -1;
//
//        public Result solotion(Node r) {
//            this.node = r;
//            this.type = 1;
//            return this;
//        }
//
//        public Result failure() {
//            this.type = -1;
//            return this;
//        }
//
//        public Result cutOff() {
//            this.type = 0;
//            return this;
//        }
//
//        public boolean isSolotion() {
//            return this.type == 1;
//        }
//
//        public boolean isFailure() {
//            return this.type == -1;
//        }
//
//        public boolean isCutOff() {
//            return this.type == 0;
//        }
//    }

    @Override
    public String toString() {
        return "Iterative Deepening";
    }
    
    
    
    
}